%global debug_package %{nil}
%global package_name openshift-builds-client
%global product_name OpenShift Builds
%global golang_version 1.19
%global opc_version 1.0.0
%global shp_version 0.11.0
%global shp_commit 20819b4140035c3087633848ce5356765bf2c35f
%global build_hash %(c=%{shp_commit}; echo ${c:0:7})
%global shp_cli_version v%{shp_version}
%global repo github.com/shipwright-io/cli.git
%global source_dir shipwright-cli-%{shp_commit}
%global source_tar shipwright-cli-20819b4140035c3087633848ce5356765bf2c35f.tar.gz
%global spec_version 0.12.0
%global spec_release 204

Name:           %{package_name}
Version:        %{opc_version}
Release:        %{spec_release}%{?dist}
Summary:        A command line tool to enhance users productivity for working with %{product_name}
License:        ASL 2.0
URL:            https://%{repo}

Source0:        %{source_tar}
BuildRequires:  golang >= %{golang_version}
Provides:       %{package_name}
Obsoletes:      %{package_name}

%description
The OpenShift Builds client is a CLI tool to work effectively with OpenShift Builds

%package redistributable
Summary:        A command line tool to enhance users productivity for working with %{product_name}
BuildRequires:  golang >= %{golang_version}
Provides:       %{package_name}-redistributable
Obsoletes:      %{package_name}-redistributable

%description redistributable
The OpenShift Builds client is a CLI tool to work effectively with OpenShift Builds


%prep
%setup -q -n %{source_dir}


%build
export CGO_ENABLED=0
GOOS=linux GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-linux-amd64 ./cmd/shp
GOOS=linux GOARCH=s390x go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-linux-s390x ./cmd/shp
GOOS=linux GOARCH=ppc64le go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-linux-ppc64le ./cmd/shp
GOOS=linux GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-linux-arm64 ./cmd/shp
GOOS=windows GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-windows-amd64 ./cmd/shp
GOOS=windows GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-windows-arm64 ./cmd/shp
GOOS=darwin GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-darwin-amd64 ./cmd/shp
GOOS=darwin GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/shipwright-io/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/shipwright-io/cli/pkg/cmd/version.clientVersion=%{shp_version}" \
           -v -o ./bin/shp-darwin-arm64 ./cmd/shp

%install
install -d %{buildroot}/%{_bindir}

%ifarch x86_64
install -D -m 0755 bin/shp-linux-amd64 %{buildroot}%{_bindir}/shp

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/shp-linux-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/shp-linux-amd64
install -p -m 755 bin/shp-darwin-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/shp-darwin-amd64
install -p -m 755 bin/shp-windows-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/shp-windows-amd64.exe
%endif

%ifarch aarch64
install -D -m 0755 bin/shp-linux-arm64 %{buildroot}%{_bindir}/shp

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/shp-linux-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/shp-linux-arm64
install -p -m 755 bin/shp-darwin-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/shp-darwin-arm64
install -p -m 755 bin/shp-windows-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/shp-windows-arm64.exe
%endif

%ifarch ppc64le
install -D -m 0755 bin/shp-linux-ppc64le %{buildroot}%{_bindir}/shp

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/shp-linux-ppc64le %{buildroot}/%{_datadir}/%{name}-redistributable/shp-linux-ppc64le
%endif

%ifarch s390x
install -D -m 0755 bin/shp-linux-s390x %{buildroot}%{_bindir}/shp

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/shp-linux-s390x %{buildroot}/%{_datadir}/%{name}-redistributable/shp-linux-s390x
%endif

%files
%license LICENSE
%{_bindir}/shp

%ifarch x86_64
%files redistributable
%license LICENSE
%{_datadir}/%{name}-redistributable/shp-linux-amd64
%{_datadir}/%{name}-redistributable/shp-darwin-amd64
%{_datadir}/%{name}-redistributable/shp-windows-amd64.exe
%endif

%ifarch ppc64le
%files redistributable
%license LICENSE
%{_datadir}/%{name}-redistributable/shp-linux-ppc64le
%endif

%ifarch s390x
%files redistributable
%license LICENSE
%{_datadir}/%{name}-redistributable/shp-linux-s390x
%endif

%ifarch aarch64
%files redistributable
%license LICENSE
%{_datadir}/%{name}-redistributable/shp-linux-arm64
%{_datadir}/%{name}-redistributable/shp-darwin-arm64
%{_datadir}/%{name}-redistributable/shp-windows-arm64.exe
%endif


%changelog